using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Drawing2D;
using System.Diagnostics;

namespace Transparency
{
    /// <summary>
    /// Summary description for TransparentForm.
    /// </summary>
    public class TransparentForm : System.Windows.Forms.Form
    {
        private IContainer components;

        public TransparentForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            this.KeyPreview = true;

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
            //this.SetStyle(ControlStyles.ResizeRedraw, true);

            //downPoint = new Point(0,0);
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.checkBoxWndProc = new System.Windows.Forms.CheckBox();
            this.SuspendLayout();
            // 
            // checkBoxWndProc
            // 
            this.checkBoxWndProc.Anchor = System.Windows.Forms.AnchorStyles.Top;
            this.checkBoxWndProc.AutoSize = true;
            this.checkBoxWndProc.BackColor = System.Drawing.Color.Transparent;
            this.checkBoxWndProc.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.checkBoxWndProc.Location = new System.Drawing.Point(62, 22);
            this.checkBoxWndProc.Name = "checkBoxWndProc";
            this.checkBoxWndProc.Size = new System.Drawing.Size(93, 17);
            this.checkBoxWndProc.TabIndex = 0;
            this.checkBoxWndProc.Text = "Use WndProc";
            this.checkBoxWndProc.UseVisualStyleBackColor = false;
            this.checkBoxWndProc.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.checkBox1_KeyPress);
            this.checkBoxWndProc.KeyDown += new System.Windows.Forms.KeyEventHandler(this.checkBox1_KeyDown);
            // 
            // TransparentForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(8, 19);
            this.ClientSize = new System.Drawing.Size(216, 102);
            this.Controls.Add(this.checkBoxWndProc);
            this.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
            this.Name = "TransparentForm";
            this.Text = "Transparency Test";
            this.TransparencyKey = System.Drawing.Color.White;
            this.Load += new System.EventHandler(this.TransparentForm_Load);
            this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.TransparentForm_MouseUp);
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.TransparentForm_Paint);
            this.SizeChanged += new System.EventHandler(this.TransparentForm_SizeChanged);
            this.DoubleClick += new System.EventHandler(this.TransparentForm_DoubleClick);
            this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.TransparentForm_MouseDown);
            this.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.TransparentForm_KeyPress);
            this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.TransparentForm_MouseMove);
            this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.TransparentForm_KeyDown);
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        int penWidth = 4;
        void TransparentForm_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            using (Pen pen = new Pen(Color.DarkBlue, penWidth))
            {
                Rectangle rect = this.ClientRectangle;
                rect.Inflate(-penWidth / 2, -penWidth / 2);
                g.FillEllipse(Brushes.Yellow, rect);
                g.DrawEllipse(pen, rect);
            }
            using (Font font = new Font(this.Font, FontStyle.Bold))
            {
                StringFormat format = new StringFormat();
                format.Alignment = StringAlignment.Center;
                format.LineAlignment = StringAlignment.Center;
                g.DrawString("an ellipse", font, Brushes.DarkBlue, this.ClientRectangle, format);
            }
        }


        GraphicsPath pathInner;
        void SetEllipseRegion()
        {
            Rectangle rect = this.ClientRectangle;
            // Assume: this.FormBorderStyle = FormBorderStyle.None
            using (GraphicsPath path = new GraphicsPath())
            {
                path.AddEllipse(rect);
                //path.AddRectangle(new Rectangle(0,0,10,10));
                this.Region = new Region(path);
            }
            pathInner = new GraphicsPath();
            rect.Inflate(-penWidth / 2, -penWidth / 2);
            pathInner.AddEllipse(rect);
        }

        void TransparentForm_Load(object sender, EventArgs e)
        {
            SetEllipseRegion();
        }

        void TransparentForm_SizeChanged(object sender, EventArgs e)
        {
            SetEllipseRegion();
        }

        private CheckBox checkBoxWndProc;

        Point downPoint = Point.Empty;

        void TransparentForm_MouseDown(object sender, MouseEventArgs e)
        {
            if (checkBoxWndProc.Checked) return;
            if (e.Button != MouseButtons.Left) return;
            downPoint = new Point(e.X, e.Y);
        }

        void TransparentForm_MouseMove(object sender, MouseEventArgs e)
        {
            if (checkBoxWndProc.Checked) return;
            if (downPoint == Point.Empty) return;
            Point location =
              new Point(
              this.Left + e.X - downPoint.X, this.Top + e.Y - downPoint.Y);
            Console.WriteLine("({0},{1}),({2},{3}),({4},{5})",
                e.X, e.Y, downPoint.X, downPoint.Y, this.Left, this.Top);
            this.Location = location;
        }

        void TransparentForm_MouseUp(object sender, MouseEventArgs e)
        {
            if (checkBoxWndProc.Checked) return;
            if (e.Button != MouseButtons.Left) return;
            downPoint = Point.Empty;
        }



        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            Point location = new Point(this.Left, this.Top);
            //Handle arrow keys
            switch (keyData)
            {
                case Keys.Up:
                    --location.Y;
                    break;

                case Keys.Left:
                    --location.X;
                    break;

                case Keys.Down:
                    ++location.Y;
                    break;

                case Keys.Right:
                    ++location.X;
                    break;

                default:
                    //other command keys are done in base
                    return base.ProcessCmdKey(ref msg, keyData);
            }

            //For arrow keys, change location and indicate handled
            this.Location = location;
            return true;
        }

        void TransparentForm_KeyDown(object sender, KeyEventArgs e)
        {

            Point location = new Point(this.Left, this.Top);

            switch (e.KeyCode)
            {
                case Keys.I:
                case Keys.Up:
                    --location.Y;
                    break;

                case Keys.J:
                case Keys.Left:
                    --location.X;
                    break;

                case Keys.K:
                case Keys.Down:
                    ++location.Y;
                    break;

                case Keys.L:
                case Keys.Right:
                    ++location.X;
                    break;
            }

            this.Location = location;
        }

        void TransparentForm_KeyPress(object sender, KeyPressEventArgs e)
        {
            System.Console.WriteLine("Press");

            Point location = new Point(this.Left, this.Top);

            switch (e.KeyChar)
            {
                case 'i':
                    --location.Y;
                    break;

                case 'j':
                    --location.X;
                    break;

                case 'k':
                    ++location.Y;
                    break;

                case 'l':
                    ++location.X;
                    break;
            }

            this.Location = location;
        }

        void TransparentForm_KeyPress_Save(object sender, KeyPressEventArgs e)
        {
            Point location = new Point(this.Left, this.Top);

            switch (e.KeyChar)
            {
                case 'i':
                    --location.Y;
                    break;

                case 'j':
                    --location.X;
                    break;

                case 'k':
                    ++location.Y;
                    break;

                case 'l':
                    ++location.X;
                    break;
            }

            this.Location = location;
        }

        private void TransparentForm_DoubleClick(object sender, System.EventArgs e)
        {
            DialogResult res = MessageBox.Show("Close window?",
                "Close Window", MessageBoxButtons.YesNo);
            if (res == DialogResult.Yes)
            {
                this.Close();
            }
        }

        private void AlterMessage(ref Message m)
        {
            Debug.WriteLine(String.Format("---{0}\nIn : {1}", ++count, m.ToString()));
            if (checkBoxWndProc.Checked)
            {
                int WM_NCHITTEST = 0x84; // winuser.h
                //int WM_CONTEXTMENU = 0x7b; // winuser.h
                //int WM_ENTERMENULOOP = 0x211; // winuser.h
                //int WM_INITMENUPOPUP = 0x117; // winuser.h
                //int WM_MENUSELECT = 0x11b; // winuser.h
                //if (m.Msg == WM_CONTEXTMENU)
                //{
                //    m.Msg = WM_INITMENUPOPUP;
                //    m.LParam = (IntPtr)0x10000;
                //    m.WParam = (IntPtr)0x3e8071f;
                //    m.Result = (IntPtr)0x0;
                //    return;
                //}
                if (m.Msg != WM_NCHITTEST)
                {
                    Debug.WriteLine("End: " + m.ToString());
                    return;
                }

                // If the user clicked on the client area,
                // ask the OS to treat it as a click on the caption
                int HTCLIENT = 1;
                int HTCAPTION = 2;

                if (m.Result.ToInt32() == HTCLIENT)
                {
                    m.Result = (IntPtr)HTCAPTION;
                }

                Debug.WriteLine("End: " + m.ToString());
                return;

                // Check for a point along the edge
                // TODO: just check along the edge
                int HTLEFT = 10;
                int HTRIGHT = 11;
                int HTTOP = 12;
                int HTTOPLEFT = 13;
                int HTTOPRIGHT = 14;
                int HTBOTTOM = 15;
                int HTBOTTOMLEFT = 16;
                int HTBOTTOMRIGHT = 17;

                // Map point around center of ellipse
                Point clientLocation = this.PointToClient(new Point(m.LParam.ToInt32()));
                if (pathInner.IsVisible(clientLocation)) return;

                int x = clientLocation.X - ClientRectangle.Width / 2;
                int y = -(clientLocation.Y - ClientRectangle.Height / 2);
                int absX = Math.Abs(x);
                int absY = Math.Abs(y);

                int centerWidth = 5;
                int edgeWidth = penWidth / 2;
                // Check for infinity and zero
                if (absX < centerWidth && y < 0) { m.Result = (IntPtr)HTBOTTOM; return; }
                else if (absX < centerWidth && y > 0) { m.Result = (IntPtr)HTTOP; return; }
                else if (absY < centerWidth && x > 0) { m.Result = (IntPtr)HTRIGHT; return; }
                else if (absY < centerWidth && x < 0) { m.Result = (IntPtr)HTLEFT; return; }
                else Debug.Assert(x != 0);

                float slope = (float)y / (float)x;
                if (x > 0 && y > 0)
                {
                    // Q1
                    if (slope > 1.67) m.Result = (IntPtr)HTTOP;
                    else if (slope < .5) m.Result = (IntPtr)HTRIGHT;
                    else m.Result = (IntPtr)HTTOPRIGHT;
                }
                else if (x > 0 && y < 0)
                {
                    // Q4
                    if (slope < -1.67) m.Result = (IntPtr)HTBOTTOM;
                    else if (slope > -0.5) m.Result = (IntPtr)HTRIGHT;
                    else m.Result = (IntPtr)HTBOTTOMRIGHT;
                }
                else if (x < 0 && y < 0)
                {
                    // Q3
                    if (slope > 1.67) m.Result = (IntPtr)HTBOTTOM;
                    else if (slope < .5) m.Result = (IntPtr)HTLEFT;
                    else m.Result = (IntPtr)HTBOTTOMLEFT;
                }
                else
                {
                    // Q2
                    if (slope < -1.67) m.Result = (IntPtr)HTTOP;
                    else if (slope > -0.5) m.Result = (IntPtr)HTLEFT;
                    else m.Result = (IntPtr)HTTOPLEFT;
                }
            }
            Debug.WriteLine("End: " + m.ToString());
        }
        static int count = 0;
        protected override void WndProc(ref Message m)
        {
           
            // Let the base class have first crack
            base.WndProc(ref m);
            AlterMessage(ref m);
        }

        private void checkBox1_KeyDown(object sender, KeyEventArgs e)
        {
            System.Console.WriteLine("Button Down");
        }

        private void checkBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            System.Console.WriteLine("Button Press");
        }

    }
}












